/* ===================================================================
   \[Xt@C
   =================================================================== */

/* ********************************************************** */
/* Include */
/* ********************************************************** */
#include "AdcDemoApl.h"

/* ********************************************************** */
/* Structure & Define */
/* ********************************************************** */
typedef enum {
  ADC_AUTO_NONE,
  ADC_AUTO_DOING
} ADC_AUTO_MODE;

typedef enum {
  ADC_DEMO_STATE_NONE, /*  */
  ADC_DEMO_STATE_AUTO  /* [h */
} ADC_DEMO_STATE;


/* ********************************************************** */
/* Local Variable */
/* ********************************************************** */
static ADC_AUTO_MODE adc_auto_mode;
static ADC_DEMO_STATE adc_demo_state;

/* ********************************************************** */
/* Local ProtoType Define */
/* ********************************************************** */



/* ================================================================== */
/* ********************************************************** */
/* Src (Internal API Function) */
/* ********************************************************** */
/* ********************************************************** */
/* Tv@F@ADC DemoAv̏                           */
/* ֐@F@AdcDemoApl_Init                                  */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
AdcDemoApl_Init (void)
{
  adc_auto_mode  = ADC_AUTO_NONE;
  adc_demo_state = ADC_DEMO_STATE_NONE;

  AdcApl_Init ();
  return;
}

/* ********************************************************** */
/* Tv@F@ADC DemoAv̎s                             */
/* ֐@F@AdcDemoApl_Exec                                  */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
AdcDemoApl_Exec (void)
{
  if (adc_auto_mode != ADC_AUTO_NONE)
	{
	  if (adc_demo_state != ADC_DEMO_STATE_NONE)
		{
		  AdcApl_Exec ();
		}
	  else
		{
		  /* Timerݒ */
		  AdcApl_Set_Timer ();

		  adc_demo_state = ADC_DEMO_STATE_AUTO;
		}
	}
  else
	{
	  if (adc_demo_state != ADC_DEMO_STATE_NONE)
		{
		  /* Timer~ */
		  AdcApl_Stop_Timer ();

		  adc_demo_state = ADC_DEMO_STATE_NONE;
		}
	}
  return;
}

/* ********************************************************** */
/* Tv@F@ADCAv Timer荞                          */
/* ֐@F@AdcDemoApl_Irq_Timer                             */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
AdcDemoApl_Irq_Timer (void)
{
  AdcApl_Irq_Timer ();
  return;
}

/* ********************************************************** */
/* Tv@F@Adc AutoMode̐ݒ                               */
/* ֐@F@AdcDemoApl_Set_AutoMode                          */
/* @F@int mode                                         */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
AdcDemoApl_Set_AutoMode (int mode)
{
  adc_auto_mode = mode;
  return;
}



/* ================================================================== */
/* ********************************************************** */
/* Src (Local Function) */
/* ********************************************************** */

