/* ===================================================================
   \[Xt@C
   =================================================================== */

/* ********************************************************** */
/* Include */
/* ********************************************************** */
#include "LedDemoApl.h"

/* ********************************************************** */
/* Structure & Define */
/* ********************************************************** */
/* [h */
typedef enum {
  LED_AUTO_NONE,
  LED_AUTO_SHIFT,
  LED_AUTO_CNT,
  LED_AUTO_ALLBLINK
} LED_AUTO_MODE;


/* ********************************************************** */
/* Local Variable */
/* ********************************************************** */
static LED_AUTO_MODE led_auto_mode;
static unsigned char led_demo_free_data;

/* ********************************************************** */
/* Local ProtoType Define */
/* ********************************************************** */



/* ================================================================== */
/* ********************************************************** */
/* Src (Internal API Function) */
/* ********************************************************** */
/* ********************************************************** */
/* Tv@F@LED DemoAv̏                           */
/* ֐@F@LedDemoApl_Init                                  */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedDemoApl_Init (void)
{
  led_auto_mode      = LED_AUTO_NONE;
  led_demo_free_data = 0;

  LedApl_Init ();
  return;
}

/* ********************************************************** */
/* Tv@F@Led DemoAv̎s                             */
/* ֐@F@LedDemoApl_Exec                                  */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedDemoApl_Exec (void)
{
  switch (led_auto_mode)
	{
	case LED_AUTO_SHIFT:
	  LedApl_Set_Type (LED_TYPE_SHIFT, LED_SHIFT_INIT_DAT);
	  break;
	case LED_AUTO_CNT:
	  LedApl_Set_Type (LED_TYPE_INC, LED_INC_INIT_DAT);
	  break;
	case LED_AUTO_ALLBLINK:
	  LedApl_Set_Type (LED_TYPE_ALLBLINK, LED_ALLBLINK_INIT_DAT);
	  break;
	case LED_AUTO_NONE:
	default:
	  LedApl_Set_Type (LED_TYPE_FREE, led_demo_free_data);
	  break;
	}

  LedApl_Exec ();
  
  return;
}

/* ********************************************************** */
/* Tv@F@LedAv Timer荞                          */
/* ֐@F@LedDemoApl_Irq_Timer                             */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedDemoApl_Irq_Timer (void)
{
  LedApl_Irq_Timer ();

  return;
}

/* ********************************************************** */
/* Tv@F@Led AutoMode̐ݒ                               */
/* ֐@F@LedDemoApl_Set_AutoMode                          */
/* @F@int mode                                         */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedDemoApl_Set_AutoMode (int mode)
{
  led_auto_mode = mode;
  return;
}

/* ********************************************************** */
/* Tv@F@Led FreeModeData̐ݒ                           */
/* ֐@F@LedDemoApl_Set_FreeModeData                      */
/* @F@unsigned char data                               */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedDemoApl_Set_FreeModeData (unsigned char data)
{
  led_demo_free_data = data;
  return;
}

/* ********************************************************** */
/* Tv@F@Led ݂̐ݒ̓ǂݍ                     */
/* ֐@F@LedDemoApl_Get_LedInfo                           */
/* @F@Ȃ                                             */
/* ߂lF@unsigned char                                    */
/* ********************************************************** */
unsigned char 
LedDemoApl_Get_LedInfo (void)
{
  return LedApl_Get_LedInfo ();
}


/* ================================================================== */
/* ********************************************************** */
/* Src (Local Function) */
/* ********************************************************** */

