#ifndef __RTC_SAMPLE_APL_H__
#define __RTC_SAMPLE_APL_H__
/* wb_[t@C */
/* ********************************************************** */
/* Include */
/* ********************************************************** */
#include "board_init.h"

/* ********************************************************** */
/* Structure & Define */
/* ********************************************************** */
typedef struct _rtc_apl_info_ {
  unsigned char year;
  unsigned char month;
  unsigned char day;
  unsigned char weekday;
  unsigned char hour;
  unsigned char min;
  unsigned char sec;
} RTC_APL_INFO;

/* RTC  */
typedef enum {
  RTC_TYPE_YEAR,	/* N */
  RTC_TYPE_MONTH,	/*  */
  RTC_TYPE_DAY,		/*  */
  RTC_TYPE_HOUR,	/*  */
  RTC_TYPE_MIN,		/*  */
  RTC_TYPE_SEC,		/* b */
  RTC_TYPE_WEEKDAY,	/* j */
  RTC_TYPE_DATE,	/* t */
  RTC_TYPE_TIME,	/*  */
  RTC_TYPE_ALL		/* S */
} RTC_TYPE;



/* ********************************************************** */
/* ProtoType Define */
/* ********************************************************** */
void RtcApl_Init (void);
void RtcApl_Exec (void);
void RtcApl_Irq_Timer (void);

void RtcApl_Write_Info (RTC_TYPE type, RTC_APL_INFO *info);
void RtcApl_Read_Info (RTC_TYPE type, RTC_APL_INFO *info);
void RtcApl_Set_Info (RTC_APL_INFO *info);
void RtcApl_Out_Info (RTC_TYPE type, RTC_APL_INFO *info);
void RtcApl_Set_Timer (void);

#endif /* __RTC_SAMPLE_APL_H__ */
