/*
 * KEIm SoM SDK main
 * EtherAplSampleSoft program
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <math.h>
#include "sys/alt_cache.h"
#include "sys/alt_alarm.h"
#include "system.h"
#include "sys/alt_irq.h"
#include <io.h>
#include "altera_avalon_timer_regs.h"
#include "altera_avalon_uart_regs.h"

#include "RtcDemoApl.h"
#include "BuzzerDemoApl.h"
#include "ServoDemoApl.h"
#include "SteppingDemoApl.h"
#include "LedDemoApl.h"
#include "AdcDemoApl.h"
#include "EtherSampleApl.h"

#include "board_init.h"

wiz_NetInfo gWIZNETINFO;

static void Display_Net_Conf(void);

int main()
{
  board_init ();

  EtherApl_Init ();

  BuzzerDemoApl_Init ();
  ServoDemoApl_Init ();
  SteppingDemoApl_Init ();
  LedDemoApl_Init ();
  AdcDemoApl_Init ();
  RtcDemoApl_Init ();

  timer_start (TIMER_1_NAME);

  RtcDemoApl_Start ();

  EtherApl_Set_NetConfig ();
  Display_Net_Conf ();
  while (1) 
	{
	  EtherApl_Exec ();
	  BuzzerDemoApl_Exec ();
	  LedDemoApl_Exec ();
	  AdcDemoApl_Exec ();
	  ServoDemoApl_Exec ();
	  SteppingDemoApl_Exec ();
 	  RtcDemoApl_Exec ();
	}

  return 0;
}

void timer0_irq_event(void* context, alt_u32 id)
{
	/* IRQ Handler TIMER0 disable */
	irq_disable( &TIMER_board_info[0].irq );

	/* TIMER0 interrupt clear */
	TIMER_write( &TIMER_board_info[0], TIMER_STR, 0 );

	/* Interrupt processing */

	/* IRQ Handler TIMER0 enavle */
	irq_enable( &TIMER_board_info[0].irq );
	/* TIMER0 count start */
	timer_start( TIMER_0_NAME );

}

/* Interval Timer gꍇ̃R[obN֐ */
void timer1_irq_event(void* context, alt_u32 id)
{
	/* IRQ Handler TIMER1 disable */
	irq_disable( &TIMER_board_info[1].irq );

	/* TIMER1 interrupt clear */
	TIMER_write( &TIMER_board_info[1], TIMER_STR, 0 );

	/* Interrupt processing */
	BuzzerDemoApl_Irq_Timer ();
	ServoDemoApl_Irq_Timer ();
	SteppingDemoApl_Irq_Timer ();
	LedDemoApl_Irq_Timer ();
	AdcDemoApl_Irq_Timer ();
	RtcDemoApl_Irq_Timer ();

	/* IRQ Handler TIMER1 enavle */
	irq_enable( &TIMER_board_info[1].irq );
	/* TIMER1 count start */
	timer_start( TIMER_1_NAME );
}

void timer2_irq_event(void* context, alt_u32 id)
{
	/* IRQ Handler TIMER2 disable */
	irq_disable( &TIMER_board_info[2].irq );

	/* TIMER2 interrupt clear */
	TIMER_write( &TIMER_board_info[2], TIMER_STR, 0 );

	/* Interrupt processing */

	/* IRQ Handler TIMER2 enavle */
	irq_enable( &TIMER_board_info[2].irq );
	/* TIMER2 count start */
	timer_start( TIMER_2_NAME );

}

void uart_cmd_event( void* context )
{
	/* UART receive Interrupt processing */

}

void eint0_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT0 disable */
	irq_disable( &EINT_board_info.dev_info[EINT0].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT0 enable */
	irq_enable( &EINT_board_info.dev_info[EINT0].irq );

}

void eint1_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT1 disable */
	irq_disable( &EINT_board_info.dev_info[EINT1].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT1 enable */
	irq_enable( &EINT_board_info.dev_info[EINT1].irq );

}

void eint2_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT2 disable */
	irq_disable( &EINT_board_info.dev_info[EINT2].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT2 enable */
	irq_enable( &EINT_board_info.dev_info[EINT2].irq );

}

void eint3_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT3 disable */
	irq_disable( &EINT_board_info.dev_info[EINT3].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT3 enable */
	irq_enable( &EINT_board_info.dev_info[EINT3].irq );

}

void eint4_irq_event( void* context, alt_u32 id)
{
	/* IRQ Handler EINT4 disable */
	irq_disable( &EINT_board_info.dev_info[EINT4].irq );

	/* Interrupt processing */

	/* IRQ Handler EINT5 enable */
	irq_enable( &EINT_board_info.dev_info[EINT4].irq );

}

void eint5_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT5 disable */
	irq_disable( &EINT_board_info.dev_info[EINT5].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT5 enable */
	irq_enable( &EINT_board_info.dev_info[EINT5].irq );

}

void eint6_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT6 disable */
	irq_disable( &EINT_board_info.dev_info[EINT6].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT6 enable */
	irq_enable( &EINT_board_info.dev_info[EINT6].irq );

}

void eint7_irq_event( void* context, alt_u32 id)
{

	/* IRQ Handler EINT7 disable */
	irq_disable( &EINT_board_info.dev_info[EINT7].irq );

	/* Interrupt processing */


	/* IRQ Handler EINT7 enable */
	irq_enable( &EINT_board_info.dev_info[EINT7].irq );

}

static void Display_Net_Conf(void)
{
	uint8_t tmpstr[6] = {0,};
	char buf[100];

	memset (&buf[0], 0, sizeof(buf));

	ctlnetwork(CN_GET_NETINFO, (void*) &gWIZNETINFO);

	// Display Network Information
	ctlwizchip(CW_GET_ID,(void*)tmpstr);

	if(gWIZNETINFO.dhcp == NETINFO_DHCP)
	  {
		sprintf(&buf[0], "\r\n===== %s NET CONF : DHCP =====\r\n",(char*)tmpstr);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	  }
	else
	  {
		sprintf(&buf[0], "\r\n===== %s NET CONF : Static =====\r\n",(char*)tmpstr);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	  }

	sprintf(&buf[0], " MAC : %02X:%02X:%02X:%02X:%02X:%02X\r\n", gWIZNETINFO.mac[0], gWIZNETINFO.mac[1], gWIZNETINFO.mac[2], gWIZNETINFO.mac[3], gWIZNETINFO.mac[4], gWIZNETINFO.mac[5]);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	sprintf(&buf[0], " IP : %d.%d.%d.%d\r\n", gWIZNETINFO.ip[0], gWIZNETINFO.ip[1], gWIZNETINFO.ip[2], gWIZNETINFO.ip[3]);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	sprintf(&buf[0], " GW : %d.%d.%d.%d\r\n", gWIZNETINFO.gw[0], gWIZNETINFO.gw[1], gWIZNETINFO.gw[2], gWIZNETINFO.gw[3]);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	sprintf(&buf[0], " SN : %d.%d.%d.%d\r\n", gWIZNETINFO.sn[0], gWIZNETINFO.sn[1], gWIZNETINFO.sn[2], gWIZNETINFO.sn[3]);
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));
	sprintf(&buf[0], "=======================================\r\n");
		uart_xfer ("UART0", &buf[0], WR, strlen(buf));

}
