//****************************************************************************
//
//! \file w5500_spi.c
//! \brief WIZnet W5500 EVB spi interface file
//!
//! Copyright (c)  2014, WIZnet Co., LTD.
//! All rights reserved.
//
//****************************************************************************

#include "w5500_spi.h"

/**
  * @brief  Initializes the peripherals used by the W5500 driver.
  * @param  None
  * @retval None
  */

void  wizchip_select(void)
{
	//Chip_GPIO_SetPinState(LPC_GPIO, 0, 2, false);	// SSEL(CS)
	int data;
	data = IORD( PIO_BASE, 0x00 );
	data = data & 0xfdff;
	IOWR( PIO_BASE, 0x00, data);
}

void  wizchip_deselect(void)
{
	//Chip_GPIO_SetPinState(LPC_GPIO, 0, 2, true);	// SSEL(CS)
	int data;
	data = IORD( PIO_BASE, 0x00 );
	data = data | 0x0200;
	IOWR( PIO_BASE, 0x00, data);
}

uint8_t wizchip_read()
{
	uint8_t rb;
	//Chip_SSP_ReadFrames_Blocking(LPC_SSP0, &rb, 1);
	//spi_read(SPI_0_BASE, &rb,  1);
	spi_xfer ("W5500", &rb, RE, 1);
	return rb;
}

void  wizchip_write(uint8_t wb)
{
	//Chip_SSP_WriteFrames_Blocking(LPC_SSP0, &wb, 1);
	//spi_write(SPI_0_BASE, &wb,  1);
  spi_xfer ("W5500", &wb, WR, 1);
}

void W5500_Init()
{
	//uint8_t tmp;
	uint8_t memsize[2][8] = { { 2, 2, 2, 2, 2, 2, 2, 2 }, { 2, 2, 2, 2, 2, 2, 2, 2 } };

	reg_wizchip_cs_cbfunc(wizchip_select, wizchip_deselect);
	reg_wizchip_spi_cbfunc(wizchip_read, wizchip_write);
	/* wizchip initialize*/
	if (ctlwizchip(CW_INIT_WIZCHIP, (void*) memsize) == -1) {
		printf("WIZCHIP Initialized fail.\r\n");
		while (1);
	}
/*
	do {
		if (ctlwizchip(CW_GET_PHYLINK, (void*) &tmp) == -1)
			printf("Unknown PHY Link stauts.\r\n");
	} while (tmp == PHY_LINK_OFF);
*/
}
